#include <bits/stdc++.h>
using namespace std;

typedef long long int64;

const int MAX = 1'000'000'000;

int main(int argc, char** argv) {
    int n;
    cin >> n;
    vector<int> d(2 * n);

    int f;
    cin >> f;
    assert(f == 2);
    int m;
    cin >> m;
    int64 x, y, z;
    cin >> x >> y >> z;
    for (int i = 0; i < m; i++) {
        cin >> d[i];
    }

    while (true) {
        for (int i = m; i < n; i++) {
            d[i % n] = (d[i - 2] * x + d[i - 1] * y + z) % MAX + 1;
        }

        for (int i = 0; i < n; i++) {
            d[i] -= i;
            d[i + n] = d[i] - n;
        }

        vector<int> p(2 * n);
        p[n] = d[n];
        for (int i = n + 1; i < 2 * n; i++) {
            p[i] = max(d[i], p[i - 1]);
        }
        p[n - 1] = d[n - 1];
        for (int i = n - 2; i >= 0; i--) {
            p[i] = max(d[i], p[i + 1]);
        }

        for (int i = 0; i < n; i++) {
            d[i] += i;
            d[i + n] = d[i];
        }

        int ans = p[0];
        int opt = 0;
        for (int i = 1; i < n; i++) {
            int v = i + max(p[i], p[i + n - 1]);
            if (v < ans) {
                ans = v;
                opt = i;
            }
        }
        if (opt == 0) {
            break;
        }

        vector<int> e(m);
        for (int i = 0; i < m; i++) {
            e[i] = d[opt + i];
        }
        for (int i = 0; i < m; i++) {
            d[i] = e[i];
        }

        cerr << ans << " " << opt << endl;
    }

    cout << n << endl << f << endl << m << " " << x << " " << y << " " << z << endl;
    for (int i = 0; i < m; i++) {
        cout << d[i];
        if (i < m - 1) {
            cout << " ";
        }
    }
    cout << endl;
}
